//BilderAnRahmenAnpassen_302d.js /CS3
// 11.12.07 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / <hsa@ringier.ch>
//Dieses Script dient zum Anpassen der ausgewhlten Bilder an ihren Rahmen

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Ein Dokument ffnen.", "Achtung");
	exit();
}

// die Auswahl testen
selItems = app.selection;
nItems = selItems.length;
if (nItems == 0) {
	alert ("Es ist nichts ausgewhlt.", "Achtung");
	exit();
}

// eine Schleife durch die ausgewhlten Rahmen
var curSel;
var curType;
for (var i=0; i<nItems; i++) {
	curSel = selItems[i];
	curType = curSel.constructor.name;
	if (curType == "Rectangle") {
		fitImage(curSel);
	}
	else if (curType == "Image") {
		curSel = curSel.parent;
		fitImage(curSel);
	}
	else if (curType == "Group") {
		parseGroup(curSel);
	}
}

// der Handler, welcher das Bild des aktuellen Rahmens anpasst
function fitImage(curSel) {
	try {
		var curImg = curSel.allGraphics[0];
		// den Inhalt des Rahmens proportional anpassen
		curImg.fit(FitOptions.FILL_PROPORTIONALLY);
		// die Bildgrsse feststellen
		var oldPc = curImg.horizontalScale;
		// den Wert auf eine Nachkommastelle runden
		var newPc = Math.ceil((oldPc*10) + 0.5) / 10;
		// den neuen Werte zuweisen
		curImg.properties = {horizontalScale:newPc, verticalScale:newPc};
		// das Bild zentrieren
		curImg.fit(FitOptions.CENTER_CONTENT);
	}
	catch (e) {
	}
}

// der Handler, welcher die Gruppen untersucht
function parseGroup(curGroup) {
	var curFrame;
	var allFrames = curGroup.allPageItems;
	var curType;
	for (var i=0; i< allFrames.length; i++) {
		curFrame = allFrames[i];
		curType = curFrame.constructor.name;
		// wie oben, wird der Type des Objekts festgestellt, 
		// die Referenz wird - falls notwendig - ergnzt 
		// und dem Handler 'fitImage' bergeben
		if (curType == "Rectangle") {
			fitImage(curFrame);
		}
		else if (curType == "Image") {
			curFrame = curFrame.parent;
			fitImage(curFrame);
		}
	}
}